
Partial Public Class InputDevice

    Public Event ChannelMessageReceived As EventHandler(Of ChannelMessageEventArgs)
    Public Event SysExMessageReceived As EventHandler(Of SysExMessageEventArgs)
    Public Event SysCommonMessageReceived As EventHandler(Of SysCommonMessageEventArgs)
    Public Event SysRealtimeMessageReceived As EventHandler(Of SysRealtimeMessageEventArgs)
    Public Event InvalidShortMessageReceived As EventHandler(Of InvalidShortMessageEventArgs)
    Public Event InvalidSysExMessageReceived As EventHandler(Of InvalidSysExMessageEventArgs)

    Protected Overridable Sub OnChannelMessageReceived(ByVal e As ChannelMessageEventArgs)
        context.Post(Function(dummy As Object) EventChannelMessageReceivedProc(e), Nothing)
    End Sub
    Private Function EventChannelMessageReceivedProc(ByVal e As ChannelMessageEventArgs) As Boolean
        RaiseEvent ChannelMessageReceived(Me, e)
        Return True
    End Function


    Protected Overridable Sub OnSysExMessageReceived(ByVal e As SysExMessageEventArgs)
        context.Post(Function(dummy As Object) OnSysExMessageReceivedProc(e), Nothing)
    End Sub
    Private Function OnSysExMessageReceivedProc(ByVal e As SysExMessageEventArgs) As Boolean
        RaiseEvent SysExMessageReceived(Me, e)
        Return True
    End Function


    Protected Overridable Sub OnSysCommonMessageReceived(ByVal e As SysCommonMessageEventArgs)
        context.Post(Function(dummy As Object) OnSysCommonMessageReceivedProc(e), Nothing)
    End Sub
    Private Function OnSysCommonMessageReceivedProc(ByVal e As SysCommonMessageEventArgs) As Boolean
        RaiseEvent SysCommonMessageReceived(Me, e)
        Return True
    End Function


    Protected Overridable Sub OnSysRealtimeMessageReceived(ByVal e As SysRealtimeMessageEventArgs)
        context.Post(Function(dummy As Object) OnSysRealtimeMessageReceivedProc(e), Nothing)
    End Sub
    Private Function OnSysRealtimeMessageReceivedProc(ByVal e As SysRealtimeMessageEventArgs) As Boolean
        RaiseEvent SysRealtimeMessageReceived(Me, e)
        Return True
    End Function

    Protected Overridable Sub OnInvalidShortMessageReceived(ByVal e As InvalidShortMessageEventArgs)
        context.Post(Function(dummy As Object) OnInvalidShortMessageReceivedProc(e), Nothing)
    End Sub
    Private Function OnInvalidShortMessageReceivedProc(ByVal e As InvalidShortMessageEventArgs) As Boolean
        RaiseEvent InvalidShortMessageReceived(Me, e)
        Return True
    End Function

    Protected Overridable Sub OnInvalidSysExMessageReceived(ByVal e As InvalidSysExMessageEventArgs)
        context.Post(Function(dummy As Object) OnInvalidSysExMessageReceivedProc(e), Nothing)
    End Sub

    Private Function OnInvalidSysExMessageReceivedProc(ByVal e As InvalidSysExMessageEventArgs) As Boolean
        RaiseEvent InvalidSysExMessageReceived(Me, e)
        Return True
    End Function

End Class
