

Imports System.ComponentModel

Partial Public Class InputDevice

    Public Overloads Overrides ReadOnly Property Handle() As Integer
        Get
            Return m_handle
        End Get
    End Property

    Public Property SysExBufferSize() As Integer
        Get
            Return m_sysExBufferSize
        End Get
        Set(ByVal value As Integer)
            If value < 1 Then
                Throw New ArgumentOutOfRangeException()
            End If
            m_sysExBufferSize = value
        End Set
    End Property

    Public Shared ReadOnly Property DeviceCount() As Integer
        Get
            Return midiInGetNumDevs()
        End Get
    End Property

End Class
