

' -------------------------------------------------- informations about the ParameterValueChanged event
Public Class ParameterChangedEventArgs
    Inherits EventArgs

    ' ---------------------------------------------- The index of the parameter that changed.
    Private m_index As Integer
    ' ---------------------------------------------- The new value of the parameter.
    Private m_value As Single

    Public Sub New(ByVal index As Integer, ByVal value As Single)
        Me.m_index = index
        Me.m_value = value
    End Sub

    Public ReadOnly Property Index() As Integer
        Get
            Return m_index
        End Get
    End Property

    Public ReadOnly Property Value() As Single
        Get
            Return m_value
        End Get
    End Property

End Class
