

' ------------------------------------------------------------------------ a synthesizer component with mono output
Public MustInherit Class MonoSynthComponent
	Inherits SynthComponent

    Private buffer As MonoBuffer

    Protected Sub New(ByVal sampleRate As SampleRate, ByVal buffer As MonoBuffer)
        MyBase.New(sampleRate)
        Me.buffer = buffer
    End Sub

    Protected Sub New(ByVal sampleRate As SampleRate, ByVal buffer As MonoBuffer, ByVal name As String)
        MyBase.New(sampleRate, name)
        Me.buffer = buffer
    End Sub

    Public Function GetBuffer() As Single()
        Return buffer.GetBuffer()
    End Function

    Friend Overloads Overrides Property BufferSize() As Integer
        Get
            Return buffer.BufferSize
        End Get
        Set(ByVal value As Integer)
            buffer.BufferSize = value
        End Set
    End Property

End Class
