

Public Partial Class Synthesizer

	Public Shared Function DecibelToString(value As Single) As String
		Dim result As String

		If value <= 0 Then
			result = "-oo"
		Else
			Dim decibel As Single = CSng((20 * Math.Log(value, 10)))

			result = "-" & decibel.ToString(FormatInfo)
		End If

		Return result
	End Function


    ' --------------------------------------- A linear interpolated value that lies between x1 and x2.
    '
	Public Shared Function LinearInterpolate(index As Single, x1 As Single, x2 As Single) As Single
        Dim fractional As Single = index - CInt(Math.Truncate(index))
		Dim difference As Single = x1 - x2
		Return x1 - difference * fractional
    End Function

End Class
