

' ----------------------------------------- functionality for generating events for driving Sequence playback
Public Interface IClock

    ' ---------------------------------------------------- occurs when an IClock generates a tick
    Event Tick As EventHandler
    ' ---------------------------------------------------- occurs when an IClock starts generating Ticks
    Event Started As EventHandler
    ' ---------------------------------------------------- occurs when an IClock continues generating Ticks
    Event Continued As EventHandler
    ' ---------------------------------------------------- occurs when an IClock is stopped
    Event Stopped As EventHandler

    ' ---------------------------------------------------- gets a value indicating whether the IClock is running
    ReadOnly Property IsRunning() As Boolean

    ReadOnly Property Ticks() As Integer

End Interface
