


Public Class MidiDeviceException
    Inherits LC.Multimedia.DeviceException

    Public Const MIDIERR_UNPREPARED As Integer = 64

    Public Const MIDIERR_STILLPLAYING As Integer = 65

    Public Const MIDIERR_NOMAP As Integer = 66              ' no configured instruments 

    Public Const MIDIERR_NOTREADY As Integer = 67           ' hardware is still busy 

    Public Const MIDIERR_NODEVICE As Integer = 68           ' port no longer connected 

    Public Const MIDIERR_INVALIDSETUP As Integer = 69       ' invalid MIF 

    Public Const MIDIERR_BADOPENMODE As Integer = 70

    Public Const MIDIERR_DONT_CONTINUE As Integer = 71      ' thru device 'eating' a message 

    Public Const MIDIERR_LASTERROR As Integer = 71


    Public Sub New(ByVal errCode As Integer)
        MyBase.New(errCode)
    End Sub

End Class
