

Imports System.Text

Public Class EmptyMonoComponent
    Inherits MonoSynthComponent

	Private m_synthesizeReplaceEnabled As Boolean = True

	Public Sub New(sampleRate As SampleRate, buffer As MonoBuffer)
		MyBase.New(sampleRate, buffer)
	End Sub

	Public Overloads Overrides Sub Synthesize(offset As Integer, count As Integer)
		' Do nothing.
	End Sub

	Public Overloads Overrides Sub Trigger(previousNote As Integer, note As Integer, velocity As Single)
		' Do nothing.
	End Sub

	Public Overloads Overrides Sub Release(velocity As Single)
		' Do nothing.
	End Sub

	Public Overloads Overrides ReadOnly Property Ordinal() As Integer
		Get
			Return 0
		End Get
	End Property

	Public Overloads Overrides Property SynthesizeReplaceEnabled() As Boolean
		Get
			Return m_synthesizeReplaceEnabled
		End Get
		Set
			m_synthesizeReplaceEnabled = value
		End Set
    End Property

End Class
