

Imports LC.Midi

Partial Public Class Synthesizer

    Private Class SynthEvent

        Private m_deltaSamples As Integer
        Private m_message As ChannelMessage

        Public Sub New(ByVal deltaSamples As Integer, ByVal message As ChannelMessage)
            Me.m_deltaSamples = deltaSamples
            Me.m_message = message
        End Sub

        Public ReadOnly Property DeltaSamples() As Integer
            Get
                Return m_deltaSamples
            End Get
        End Property

        Public ReadOnly Property Message() As ChannelMessage
            Get
                Return m_message
            End Get
        End Property
    End Class

End Class
