

Imports System.ComponentModel
Imports System.Threading

Public Class PostCompletedEventArgs
    Inherits AsyncCompletedEventArgs

    Private m_callback As SendOrPostCallback

    Public Sub New(ByVal callback As SendOrPostCallback, ByVal [error] As Exception, ByVal state As Object)
        MyBase.New([error], False, state)
        Me.m_callback = callback
    End Sub

    Public ReadOnly Property Callback() As SendOrPostCallback
        Get
            Return m_callback
        End Get
    End Property

End Class
