

Imports System.Text
Imports System.Runtime.InteropServices
Imports LC.Timers

Friend NotInheritable Class NativeMethods
	<DllImport("winmm.dll")> _
	Public Shared Function waveOutOpen(ByRef handle As Int32, deviceID As Integer, ByRef format As WaveFormat, dummy As IntPtr, instance As IntPtr, flags As Integer) As Integer
	End Function

	<DllImport("winmm.dll")> _
	Public Shared Function waveOutClose(handle As Int32) As Integer
	End Function

	<DllImport("winmm.dll")> _
	Public Shared Function waveOutReset(handle As Int32) As Integer
	End Function

	<DllImport("winmm.dll")> _
	Public Shared Function waveOutPrepareHeader(handle As Int32, headerPtr As IntPtr, sizeOfWaveHeader As Integer) As Integer
	End Function

	<DllImport("winmm.dll")> _
	Public Shared Function waveOutUnprepareHeader(handle As Int32, headerPtr As IntPtr, sizeOfWaveHeader As Integer) As Integer
	End Function

	<DllImport("winmm.dll")> _
	Public Shared Function waveOutWrite(handle As Int32, headerPtr As IntPtr, sizeOfWaveHeader As Integer) As Integer
	End Function

	<DllImport("winmm.dll")> _
	Public Shared Function waveOutGetDevCaps(deviceID As Integer, ByRef caps As WaveOutCaps, sizeOfWaveOutCaps As Integer) As Integer
	End Function

	<DllImport("winmm.dll")> _
	Public Shared Function waveOutGetNumDevs() As Integer
	End Function

	<DllImport("winmm.dll")> _
	Public Shared Function waveOutPause(handle As Int32) As Integer
	End Function

	<DllImport("winmm.dll")> _
	Public Shared Function waveOutRestart(handle As Int32) As Integer
	End Function

	<DllImport("winmm.dll")> _
	Public Shared Function waveOutGetPitch(handle As Int32, ByRef pitch As Integer) As Integer
	End Function

	<DllImport("winmm.dll")> _
	Public Shared Function waveOutSetPitch(handle As Int32, pitch As Integer) As Integer
	End Function

	<DllImport("winmm.dll")> _
	Public Shared Function waveOutGetPlaybackRate(handle As Int32, ByRef rate As Integer) As Integer
	End Function

	<DllImport("winmm.dll")> _
	Public Shared Function waveOutSetPlaybackRate(handle As Int32, rate As Integer) As Integer
	End Function

	<DllImport("winmm.dll")> _
	Public Shared Function waveOutGetVolume(handle As Int32, ByRef volume As Integer) As Integer
	End Function

	<DllImport("winmm.dll")> _
	Public Shared Function waveOutSetVolume(handle As Int32, volume As Integer) As Integer
	End Function

	<DllImport("winmm.dll")> _
	Public Shared Function waveOutGetPosition(handle As Int32, ByRef time As Time, sizeOfTime As Integer) As Integer
	End Function

	<DllImport("winmm.dll")> _
	Public Shared Function waveOutGetErrorText(errCode As Integer, message As StringBuilder, sizeOfMessage As Integer) As Integer
	End Function

	Private Sub New()
    End Sub

End Class
